--*********************************************************************************
--* This file is part of the RIBit Renderman(tm) exporter for max
--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes --*********************************************************************************

plugin modifier mo_RIBit_Particles
	name:"RIBit Particles"
	category:"RIBit"
	classID:#(0x8b94596f, 0xd2e0bc06)
	version:1
(

	parameters RIBit_Attributes rollout:ro_RIBit_Attributes
	(
		Type			type:#integer ui:rbType default:1 animatable:false
		ColorPP			type:#string ui:edColorPP default:""
		OpacityPP 		type:#string ui:edOpacityPP default:""

		SizePP	 		type:#string ui:edSizePP default:""
		RIBboxPP 		type:#string ui:edRIBBoxPP default:""
	)

	
	rollout ro_RIBit_Attributes "RIBit Particle Attributes"
	(
		local editBoxMode = 0
	
		rollout ro_RIBit_params_edit "Edit Particle Parameters"
		(
			local editBoxMode = 0
		
			editText edRIBCode "" width:400 height:200 pos:[5,5] text:""
			button bnCancel "Cancel" width:60 height:16 across:2 
			button bnOK "OK" width:60 height:16
			

			on ro_RIBit_params_edit open do (
				editBoxMode = ro_RIBit_Attributes.editBoxMode
				case editBoxMode of (
					1: edRIBCode.text = ro_RIBit_Attributes.edColorPP.text
					2: edRIBCode.text = ro_RIBit_Attributes.edOpacityPP.text
					3: edRIBCode.text = ro_RIBit_Attributes.edSizePP.text
					4: edRIBCode.text = ro_RIBit_Attributes.edRIBBoxPP.text
				)
			)

			on ro_RIBit_params_edit close do (
				local lines = filterString edRIBCode.text "\n\r"
				local str = ""
				if lines.count > 0 then (
					str = lines[1]
					for i = 2 to lines.count do 
						str += "\n" + lines[i]
				)
				case editBoxMode of (
					1: ro_RIBit_Attributes.edColorPP.text = str
					2: ro_RIBit_Attributes.edOpacityPP.text = str
					3: ro_RIBit_Attributes.edSizePP.text = str
					4: ro_RIBit_Attributes.edRIBBoxPP.text = str
				)
				ro_RIBit_Attributes.editBoxMode = 0
			)
			
			on bnCancel pressed do (
				case editBoxMode of (
					1: edRIBCode.text = ro_RIBit_Attributes.edColorPP.text
					2: edRIBCode.text = ro_RIBit_Attributes.edOpacityPP.text
					3: edRIBCode.text = ro_RIBit_Attributes.edSizePP.text
					4: edRIBCode.text = ro_RIBit_Attributes.edRIBBoxPP.text
				)
				destroyDialog ro_RIBit_params_edit
			)
				
			on bnOK pressed do (
				destroyDialog ro_RIBit_params_edit
			)
		) -- end ro_RIBit_params_edit rollout
		

		editText edColorPP "" width:1 height:1 visible:false pos:[0,0]
		editText edOpacityPP "" width:1 height:1 visible:false pos:[0,0]
		editText edSizePP "" width:1 height:1 visible:false pos:[0,0]
		editText edRIBBoxPP "" width:1 height:1 visible:false pos:[0,0]
	
	
	group "Particle Type " (
			radiobuttons rbType "" labels:#("Point        ", "Curve", "Sphere", "Blobby", "Sprite") align:#left columns:2
		)
	
		group "Per-Particle Parameters " (
			button bnColor "Edit Color..." width:130
			button bnOpacity "Edit Opacity..." width:130
			button bnSize "Edit Size..." width:130
			button bnRIBBox "Edit RIB Box..." width:130
			
		)


		-- Event Handlers
		------------------

		on bnColor pressed do (
			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = 1
			createDialog ro_RIBit_params_edit width:410
		)
		on bnOpacity pressed do (
			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = 2
			createDialog ro_RIBit_params_edit width:410
		)
		on bnSize pressed do (

			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = 3
			createDialog ro_RIBit_params_edit width:410
		)
		on bnRIBBox pressed do (

			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = 4
			createDialog ro_RIBit_params_edit width:410
		)
		
	) -- end ro_RIBit_Attributes rollout	


 ) -- end mo_RIBit_Geometry modifier




	


