--*********************************************************************************

--* This file is part of the RIBit Renderman(tm) exporter for max

--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes

--*********************************************************************************

plugin modifier mo_RIBit_Shaders
	name:"RIBit Rendering"
	category:"RIBit"
	classID:#(0x5511d948, 0x52866c3a)
	version:1
(

	parameters RIBit_Attributes rollout:ro_RIBit_Attributes
	(
		Color			type:#color ui:cpColor default:[125,125,125]
		Opacity 		type:#color ui:cpOpacity default:[255,255,255]
		Surface  		type:#string ui:edSurface default:"matte"
		SurfaceParams	type:#string ui:edEditSurfaceParams default:""
		Displacement  	type:#string ui:edDisplacement default:""
		DisplacementParams	type:#string ui:edEditDisplacementParams default:""
		Atmosphere	 		type:#string ui:edAtmosphere default:""	
		AtmosphereParams	type:#string ui:edEditAtmosphereParams default:""
		ShadingInterpolation type:#string default:"smooth"
		matte				 type:#boolean default:false ui:cbMatte
		
		on Color set val do 
			if $ != undefined then
				$.wirecolor = val
		
	)

	
	rollout ro_RIBit_Attributes "RIBit Rendering Attributes"
	(
	
	local editBoxMode = 0
	
		rollout ro_RIBit_params_edit "Edit Shader Parameters"
		(
			local editBoxMode = 0
		
			editText edRIBCode "" width:400 height:200 pos:[5,5] text:""
			button bnCancel "Cancel" width:60 height:16 across:2 
			button bnOK "OK" width:60 height:16
			

			on ro_RIBit_params_edit open do (
				editBoxMode = ro_RIBit_Attributes.editBoxMode
				case editBoxMode of (
					1: edRIBCode.text = ro_RIBit_Attributes.edEditSurfaceParams.text
					2: edRIBCode.text = ro_RIBit_Attributes.edEditDisplacementParams.text
					3: edRIBCode.text = ro_RIBit_Attributes.edEditAtmosphereParams.text
				)
			)

			on ro_RIBit_params_edit close do (
				local lines = filterString edRIBCode.text "\n\r"
				local str = ""
				if lines.count > 0 then (
					str = lines[1]
					for i = 2 to lines.count do 
						str += "\n" + lines[i]
				)
				case editBoxMode of (
					1: ro_RIBit_Attributes.edEditSurfaceParams.text = str
					2: ro_RIBit_Attributes.edEditDisplacementParams.text = str
					3: ro_RIBit_Attributes.edEditAtmosphereParams.text = str
				)
				ro_RIBit_Attributes.editBoxMode = 0
			)
			
			on bnCancel pressed do (
				case editBoxMode of (
					1: edRIBCode.text = ro_RIBit_Attributes.edEditSurfaceParams.text
					2: edRIBCode.text = ro_RIBit_Attributes.edEditDisplacementParams.text
					3: edRIBCode.text = ro_RIBit_Attributes.edEditAtmosphereParams.text
				)
				destroyDialog ro_RIBit_params_edit
			)
				
			on bnOK pressed do (
				destroyDialog ro_RIBit_params_edit
			)
		) -- end ro_RIBit_params_edit rollout
		

		editText edEditSurfaceParams "" width:1 height:1 visible:false pos:[0,0]
		editText edEditDisplacementParams "" width:1 height:1 visible:false pos:[0,0]
		editText edEditAtmosphereParams "" width:1 height:1 visible:false pos:[0,0]
	
		group "Colors " (
			colorpicker cpColor "Color        " align:#right modal:false title:"Object Color"
			colorpicker cpOpacity "Opacity       " align:#right modal:false title:"Object Opacity"
		)
		group "Shaders " (
			edittext edSurface "Surface" align:#right fieldWidth:90 across:2 offset:[57,0]
			button bnEditSurfaceParams "P" width:14 height:16 tooltip:"Edit shader parameters..." align:#right offset:[5,0]
			edittext edDisplacement "Displ" align:#right fieldWidth:90 across:2 offset:[57,0]
			button bnEditDisplacementParams "P" width:14 height:16 tooltip:"Edit shader parameters..." align:#right offset:[5,0]
			edittext edAtmosphere "Atmos" align:#right fieldWidth:90 across:2 offset:[57,0]
			button bnEditAtmosphereParams "P" width:14 height:16 tooltip:"Edit shader parameters..." align:#right offset:[5,0]

		)
		dropDownList dlShadingInterpolation "Shad Interp" align:#left items:#("smooth","constant")
		checkbox cbMatte "Matte"


		-- Event Handlers
		------------------

		on bnEditSurfaceParams pressed do (
			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = 1
			createDialog ro_RIBit_params_edit width:410
		)
		on bnEditDisplacementParams pressed do (
			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = 2
			createDialog ro_RIBit_params_edit width:410
		)
		on bnEditAtmosphereParams pressed do (

			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = 3
			createDialog ro_RIBit_params_edit width:410
		)
		
		on dlShadingInterpolation selected val do (
			ShadingInterpolation = dlShadingInterpolation.selected
		)
		
		on ro_RIBit_Attributes open do (
			dlShadingInterpolation.selection = case ShadingInterpolation of ("smooth":1;"constant":2;)
		)

	) -- end ro_RIBit_Attributes rollout	




) -- end mo_RIBit_Geometry modifier




	

