--*********************************************************************************
--* This file is part of the RIBit Renderman(tm) exporter for max
--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes
--*********************************************************************************


struct s_RIBit_Motion (
	settings = s_RIBit_Settings(),
	func = undefined,
	funcParams = #(),
	dependsOn = #(),
	bypass = false,
	indent = "",
	fileHandle,
	
	
	
fn isDependsOnAnimated =
	(
		local returnVal = false
		for i in dependsOn do 
			returnVal = returnVal or i
		returnVal
	),
	
	fn MotionBegin =
	(
		if fileHandle != undefined and settings.frame != undefined then (
			format "%MotionBegin [" indent to:fileHandle
			local numMBFrames = ceil (settings.shutterAngle / 360.)
			for i = 0 to numMBFrames by (numMBFrames / (settings.subFrames - 1)) do
				format "%%" (if i == 0 then "" else " ") i to:fileHandle
			format "]\n" to:fileHandle
			indent += "\t"
		)
	),
	
	fn MotionEnd =
	(
		if fileHandle != undefined and settings.frame != undefined then (
			indent = subString indent 1 (indent.count - 1)
			format "%MotionEnd\n" indent to:fileHandle
		)
	),
	
	fn write =
	(
		if fileHandle == undefined then return()

		if not bypass and settings.useMotionBlur == true and settings.frame != undefined and isDependsOnAnimated() then (
			MotionBegin()
			local numMBFrames = ceil (settings.shutterAngle / 360.)
			for i = 0 to numMBFrames by (numMBFrames / (settings.subFrames - 1)) do (
				at time (settings.frame + i) (
					if func != undefined then
						func params:funcParams
				)
			)
			MotionEnd()
		) else (
			if func != undefined then
				at time settings.frame (func params:funcParams)
		)		
	)
) -- end of s_RIBit_Motion srtuct


